// Copyright 2015-2016 Espressif Systems (Shanghai) PTE LTD
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at

//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.



#include "sdkconfig.h"
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include <esp_types.h>
#include "esp_err.h"
#include "esp_intr_alloc.h"
#include "esp_attr.h"
#include "esp_freertos_hooks.h"
#include "xtensa/core-macros.h"

//called as a task 2 times, once for each core
static void int_flooder_setup(void *param) {
	esp_err_t err;
	XTHAL_SET_CCOMPARE(2, XTHAL_GET_CCOUNT()+240000000); //1 sec delay
	err=esp_intr_alloc(ETS_INTERNAL_TIMER2_INTR_SOURCE, ESP_INTR_FLAG_LEVEL5|ESP_INTR_FLAG_IRAM, NULL, NULL, NULL);
	assert(err==ESP_OK);
	vTaskDelete(NULL);
}

void __attribute__((constructor)) int_flooder_init() {
//	return;
	ets_printf("Setting up interrupt flooding...\n");
	xTaskCreatePinnedToCore(&int_flooder_setup, "fld_c0", 6000, NULL, 6, NULL, 0);
	xTaskCreatePinnedToCore(&int_flooder_setup, "fld_c1", 6000, NULL, 6, NULL, 1);
}

void intflooder_dummy() {
	printf("intflooder_dummy\n");
}
